



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>双向链表、双向循环链表的JS实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">双向链表、双向循环链表的JS实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 02:19:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>关于链表简介、单链表、单向循环链表、JS中的使用以及扩充方法： &nbsp;<a href="http://blog.csdn.net/zhuwq585/article/details/53130741" rel="external nofollow noreferrer">单链表、循环链表的JS实现</a></p>
<p>关于四种链表的完整封装：&nbsp;<a href="https://github.com/zhuwq585/Data-Structure-in-JavaScript/blob/master/LinkedList.js" rel="external nofollow noreferrer">https://github.com/zhuwq585/Data-Structure-in-JavaScript/blob/master/LinkedList.js</a></p>
<p>双向链表：单向链表只能向着一个方向遍历链表节点，而在节点指针域中增加了前向指针的双向链表，则可以向着两个方向遍历节点。这使得双向链表也可以在任何一个节点遍历整个链表。</p>
<pre class="prettyprint linenums">function DoublyLinkedList() {<br />
	var Node = function(element) {<br />
		this.element = element;<br />
		this.next = null;<br />
		this.prev = null;<br />
	};

	var length = 0,<br />
		head = null,<br />
		tail = null;

	this.append = function(element){<br />
		var node = Node(element),<br />
		    current,<br />
		    previous;

		if(!head){<br />
			head = node;<br />
			tail = node;<br />
		}else{<br />
			current = head;<br />
			while(current){<br />
				previous = current;<br />
				current = current.next;<br />
			}

			node.next = current;<br />
			current.prev = node;<br />
			previous.next = node;<br />
			node.prev = previous;<br />
		}

		length++;<br />
		return true;<br />
	}

	this.insert = function(position,element){<br />
		if(position &gt; -1 &amp;&amp; position &lt; length){<br />
			var node = new Node(element),<br />
			    current = head,<br />
			    previous,<br />
			    index = 0;

			if(position === 0){

				if(!head){<br />
					head = node;<br />
					tail = node;<br />
				}else{<br />
					node.next = current;<br />
					current.prev = node;<br />
					head = node;<br />
				}

			}else if (position === length -1){<br />
				current = tail;<br />
				current.next = node;<br />
				node.prev = current;<br />
			}else {<br />
				while(index++ &lt; position){<br />
					previous = current;<br />
					current = current.next;<br />
				}<br />
				node.next = current;<br />
				previous.next = node;<br />
				current.prev = node;<br />
				node.prev = previous;<br />
			}

			length++;<br />
			return true;<br />
		}else{<br />
			return false;<br />
		}<br />
	};

	this.removeAt = function(position){<br />
		if(position &gt; -1 &amp;&amp; position &lt; length){<br />
			var current = head,<br />
			    index = 0,<br />
			    previous;

			if (position === 0) {<br />
				head = current.next;

				if(length === 1){<br />
					tail = null;<br />
				}else{<br />
					head.prev = null;<br />
				}<br />
			}else if(position === length - 1){<br />
				current = tail;<br />
				tail = current.prev;<br />
				tail.next = null;<br />
			} else{<br />
				while(index++ &lt; position){<br />
					previous = current;<br />
					current = current.next;<br />
				}

				previous.next = current.next;<br />
				current.next.prev = previous;<br />
			};<br />
			length-- ;

			return current.element;<br />
		}else{<br />
			return false;<br />
		}<br />
	};

	this.remove = function(element){<br />
		var current = head,<br />
		    previous;

		if(current.element === element){<br />
			head = current.next;<br />
		}<br />
		previous = current;<br />
		current = current.next;

		while(current){<br />
			if (current.element = element) {<br />
				previous.next = current.next;<br />
				current.next.prev = previous;<br />
			}else{<br />
				previous = current;<br />
				current = current.next;<br />
			}<br />
		}<br />
		return false;<br />
	};

	this.remove = function(){<br />
		if (length === 0) {<br />
			return false;<br />
		};

		var current = head,<br />
			previous;

		if(length === 1){<br />
			head = null;<br />
			tail = null;<br />
			length--;<br />
			return current.element;<br />
		}

		while(current){<br />
			previous = current;<br />
			current = current.next;<br />
		}

		previous.next = null;<br />
		length--;<br />
		return current.element;<br />
	};

	this.indexOf = function(element){<br />
		var current = head,<br />
		    index = 0;

		while(current &amp;&amp; index++ &lt; length){<br />
			if (current.element === element) {<br />
				return index;<br />
			};<br />
			current = current.next;<br />
		}

		return false;<br />
	};

	this.isEmpty = function(){<br />
		return length === 0;<br />
	};

	this.size = function(){<br />
		return length;<br />
	};

	this.toString = function(){<br />
		var current = head,<br />
		    string = '';

		while(current){<br />
			string += current.element;<br />
			current = current.next;<br />
		}<br />
		return string;<br />
	};

	this.getHead = function(){<br />
		return head;<br />
	};

	this.getTail = function(){<br />
		return tail;<br />
	};<br />
}</pre>

<p>双向循环链表：将双向链表的头尾指针相连，就构成了双向循环链表。这种链表从任意一个节点都可以同时向两个方向进行节点遍历，查询节点的速度也是最快的。</p>
<pre class="prettyprint linenums">/*双向循环链表*/<br />
function DoublyCircularLinkedList(){<br />
	var Node = function(element){<br />
		this.element = element;<br />
		this.next = null;<br />
		this.prev = null;<br />
	};

	var length = 0,<br />
		head = null,<br />
		tail = null;

	this.append = function(element){<br />
		var node = new Node(element),<br />
		    current,<br />
		    previous;

		if (!head) {<br />
			head = node;<br />
			tail = node;<br />
			head.prev = tail;<br />
			tail.next = head;<br />
		}else{<br />
			current = head;

			while(current.next !== head){<br />
				previous = current;<br />
				current = current.next;<br />
			}

			current.next = node;<br />
			node.next = head;<br />
			node.prev = current;<br />
		};

		length++;<br />
		return true;<br />
	};

	this.insert = function(position, element){<br />
		if(position &gt;= 0 &amp;&amp; position &lt;= length){<br />
			var node = new Node(element),<br />
			    index = 0,<br />
			    current = head,<br />
		            previous;

			if(position === 0){

				if(!head){

					node.next = node;<br />
					node.tail = node;<br />
					head = node;<br />
					tail = node;

				}else{

					current.prev = node;<br />
					node.next = current;<br />
					head = node;<br />
					node.prev = tail;

				}

			}else if(position === length){<br />
				current = tail;

				current.next = node;<br />
				node.prev = current;<br />
				tail = node;<br />
				node.next = head;<br />
			}else{

				while(index++ &lt; position){<br />
					previous = current;<br />
					current = current.next;<br />
				}

				current.prev = node;<br />
				node.next = current;<br />
				previous.next = node;<br />
				node.prev = previous;

			}

			length++;<br />
			return true;<br />
		}else{<br />
			return false;<br />
		}<br />
	};

	this.removeAt = function(position){<br />
		if(position &gt; -1 &amp;&amp; position &lt; length){

			var current = head,<br />
			    index = 0,<br />
			    previous;

			if(position === 0){

				current.next.previous = tail;<br />
				head = current.next;

			}else if(position === length - 1){

				current = tail;

				current.prev.next = head;<br />
				head.prev = current.prev;<br />
				tail = current.prev;<br />
			}else{

				while(index++ &lt; position){<br />
					previous = current;<br />
					current = current.next;<br />
				}

				previous.next = current.next;<br />
				current.next.prev = previous;

			}

			length--;<br />
			return true;<br />
		}else{<br />
			return false;<br />
		}<br />
	};

	this.remove = function(element){<br />
		var current = head,<br />
		    previous,<br />
		    indexCheck = 0;

		while(current &amp;&amp; indexCheck &lt; length){<br />
			if(current.element === element){<br />
				if(indexCheck === 0){<br />
					current.next.prev = tail;<br />
					head = current.next;<br />
				}else{<br />
					current.next.prev = previous;<br />
					previous.next = current.next;<br />
				}<br />
				length--;<br />
				return true;<br />
			}

			previous = current;<br />
			current = current.next;<br />
			indexCheck++;<br />
		}

		return false;<br />
	};

	this.remove = function(){<br />
		if(length === 0){<br />
			return false;<br />
		}

		var current = head,<br />
			previous,<br />
			indexCheck = 0;

		if(length === 1){<br />
			head = null;<br />
			tail = null;<br />
			length--;<br />
			return current.element;<br />
		}

		while(indexCheck++ &lt; length){<br />
			previous = current;<br />
			current = current.next;<br />
		}

		previous.next = head;<br />
		tail = previous.next;<br />
		length--;<br />
		return current.element;<br />
	};

	this.indexOf = function(element){<br />
		var current = head,<br />
		    index = 0;

		while(current &amp;&amp; index++ &lt; length){<br />
			if(current.element === element){<br />
				return index;<br />
			}<br />
			current = current.next;<br />
		}

		return false;<br />
	};

	this.toString = function(){<br />
		var current = head,<br />
		    indexCheck = 0,<br />
		    string = '';

		while(current &amp;&amp; indexCheck &lt; length){<br />
			string += current.element;<br />
			indexCheck++;<br />
			current = current.next;<br />
		}	

		return string;<br />
	};

	this.isEmpty = function(){<br />
		return length === 0;<br />
	};

	this.getHead = function(){<br />
		return head;<br />
	};

	this.getTail = function(){<br />
		return tail;<br />
	};

	this.size = function(){<br />
		return length;<br />
	};<br />
}</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93xreg9.html">py-faster-rcnn之从solver文件创建solver对象，建立pythonlayer</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zkkxd8.html">android常犯错误记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pg5zk9.html">Mybatis之关联查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn11jl28.html">python&lowbar;way &comma;day1 编译安装python3、基础及流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1d1d8.html">java递归方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjgpjz9.html">PagerSlidingTabStrip 高亮选中标题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd023dq.html">Python Requests库：HTTP for Humans</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kzpe59.html">hdu 5138</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge4m6l8.html">如何在Android中添加系统服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdko59.html">MySQL IO线程及相关参数调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/950l4e68.html">MySQL 并行复制从库发生自动重启分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z4wz19.html">设置redis服务开机自启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rj0n49.html">article2pdf &lpar;Wordpress plug-in&rpar; Multiple vulnerabilities&lpar;CVE-2019-1000031&comma; CVE-2019-1010257&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25v1rvq.html">free命令详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkypyd8.html">文件处理-智能检测编码的工具（chardet）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902kjdnq.html">&lbrack;Windows&rsqb;&lowbar;&lbrack;中级&rsqb;&lowbar;&lbrack;崩溃报告的中级解决方案&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4pkplq.html">shadowshocks下载地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/96362439.html">configChanges</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jejwve8.html">在阿里云服务器上配置CentOS&plus;Nginx&plus;Python&plus;Flask环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/9je12xw8.html">python web 框架的基本逻辑练习题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/jqdpw4zq.html">php的memcache安装，在window10下面</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlj1w19.html">python string模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdpjyzq.html">整理文件，翻出了以前作的ps稿 &lpar;&Hat;o&Hat;&rpar;c旦&grave;&grave;</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ge31e8.html">MVC安全防护</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqljo7k9.html">使用Java的Frame类编写的QQ登录界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwj5vk8.html">Windows&plus;Caffe&plus;VS2013&plus;python接口配置过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pdkx49.html">移居 GitHub</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2jmzv8.html">SQLite&period;Net-PCLUSING SQLITE IN WINDOWS 10 UNIVERSAL APPS</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2j2e38.html">IIS6&period;0 web&period;config</a>
			</li>
						<li><a href="https://www.batexi.com/a/390mp538.html">cookie的存储和获取</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
